Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -505,583 +565,743 @@
        LOGICAL      ::  flag_set !< steering variable for advection flags
    
-       ALLOCATE( advc_flags_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                  &
-                 advc_flags_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-       advc_flags_1 = 0
-       advc_flags_2 = 0
-       IF ( scalar_advec == 'ws-scheme' )  THEN
-!
-!--       Set flags to steer the degradation of the advection scheme in advec_ws
-!--       near topography, inflow- and outflow boundaries as well as bottom and
-!--       top of model domain. advc_flags_1 remains zero for all non-prognostic
-!--       grid points.
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-!
-!--                scalar - x-direction
-!--                WS1 (0), WS3 (1), WS5 (2)
-                   IF ( ( .NOT. BTEST(wall_flags_0(k,j,i+1),0)                 &
-                    .OR.  .NOT. BTEST(wall_flags_0(k,j,i+2),0)                 &   
-                    .OR.  .NOT. BTEST(wall_flags_0(k,j,i-1),0) )               &
-                      .OR.  ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                            .AND.  i == nxl   )                                &
-                      .OR.  ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                            .AND.  i == nxr   ) )                              &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 0 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+3),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i+1),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i+2),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i-1),0)             &
-                            )                       .OR.                       &
-                            ( .NOT. BTEST(wall_flags_0(k,j,i-2),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i+1),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i+2),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j,i-1),0)             &
-                            )                                                  &
-                                                    .OR.                       &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr-1 )    .OR.                       &
-                            ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                              .AND. i == nxlu  ) )                             & ! why not nxl+1
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 1 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j,i+2),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j,i+3),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j,i-1),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j,i-2),0) )                   &
-                   THEN 
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 2 )
-                   ENDIF
-!
-!--                scalar - y-direction
-!--                WS1 (3), WS3 (4), WS5 (5)
-                   IF ( ( .NOT. BTEST(wall_flags_0(k,j+1,i),0)                 &
-                    .OR.  .NOT. BTEST(wall_flags_0(k,j+2,i),0)                 &   
-                    .OR.  .NOT. BTEST(wall_flags_0(k,j-1,i),0))                &
-                      .OR.  ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                            .AND.  j == nys   )                                &
-                      .OR.  ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                            .AND.  j == nyn   ) )                              &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 3 )
-!
-!--                WS3
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+3,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j+1,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j+2,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j-1,i),0)             &
-                            )                       .OR.                       &
-                            ( .NOT. BTEST(wall_flags_0(k,j-2,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j+1,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j+2,i),0)             &
-                       .AND.        BTEST(wall_flags_0(k,j-1,i),0)             &
-                            )                                                  &
-                                                    .OR.                       &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j == nysv  )    .OR.                       & ! why not nys+1
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn-1 ) )                             &          
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 4 )
-!
-!--                WS5
-                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j+2,i),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j+3,i),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j-1,i),0)                     &
-                      .AND. BTEST(wall_flags_0(k,j-2,i),0) )                   &
-                   THEN 
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 5 )
-                   ENDIF
-! 
-!--                scalar - z-direction
-!--                WS1 (6), WS3 (7), WS5 (8)
-                   IF ( k == nzb+1 )  THEN
-                      k_mm = nzb
-                   ELSE 
-                      k_mm = k - 2
-                   ENDIF
-                   IF ( k > nzt-1 )  THEN
-                      k_pp = nzt+1
-                   ELSE 
-                      k_pp = k + 2
-                   ENDIF
-                   IF ( k > nzt-2 )  THEN
-                      k_ppp = nzt+1
-                   ELSE 
-                      k_ppp = k + 3
-                   ENDIF
-
-                   flag_set = .FALSE.
-                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),0)  .AND.            &
-                              BTEST(wall_flags_0(k,j,i),0)    .OR.             &
-                        .NOT. BTEST(wall_flags_0(k_pp,j,i),0) .AND.            &                              
-                              BTEST(wall_flags_0(k,j,i),0)    .OR.             &
-                        k == nzt )                                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 6 )
-                      flag_set = .TRUE.
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),0)    .OR.    &
-                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),0) ) .AND.   & 
-                                  BTEST(wall_flags_0(k-1,j,i),0)  .AND.        &
-                                  BTEST(wall_flags_0(k,j,i),0)    .AND.        &
-                                  BTEST(wall_flags_0(k+1,j,i),0)  .AND.        &
-                                  BTEST(wall_flags_0(k_pp,j,i),0) .OR.         &    
-                            k == nzt - 1 )                                     &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 7 )
-                      flag_set = .TRUE.
-                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),0)                    &
-                     .AND.  BTEST(wall_flags_0(k-1,j,i),0)                     &
-                     .AND.  BTEST(wall_flags_0(k,j,i),0)                       &
-                     .AND.  BTEST(wall_flags_0(k+1,j,i),0)                     &
-                     .AND.  BTEST(wall_flags_0(k_pp,j,i),0)                    &
-                     .AND.  BTEST(wall_flags_0(k_ppp,j,i),0)                   &
-                     .AND. .NOT. flag_set )                                    &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 8 )
-                   ENDIF
-
-                ENDDO
+       advc_flags_m = 0
+
+!
+!--    Set advc_flags_m to steer the degradation of the advection scheme in advec_ws
+!--    near topography, inflow- and outflow boundaries as well as bottom and
+!--    top of model domain. advc_flags_m remains zero for all non-prognostic
+!--    grid points.
+!--    u-component
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+!  
+!--             At first, set flags to WS1. 
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!--             in order to handle the left/south flux.
+!--             near vertical walls. 
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )
+!
+!--             u component - x-direction
+!--             WS1 (0), WS3 (1), WS5 (2)
+                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),1)  .OR.                &
+                         ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
+                           .AND. i <= nxlu  )    .OR.                          &
+                         ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
+                           .AND. i == nxr   ) )                                &
+                THEN                                                           
+                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )      
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),1)  .AND.         &
+                                 BTEST(wall_flags_0(k,j,i+1),1)  .OR.          &
+                           .NOT. BTEST(wall_flags_0(k,j,i-1),1) )              &
+                                                     .OR.                      &
+                         ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
+                           .AND. i == nxlu+1) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 1 )       
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
+                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),1)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i+2),1)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i-1),1) )                      &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 2 )       
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
+                ENDIF                                                          
+!                                                                              
+!--             u component - y-direction                                      
+!--             WS1 (3), WS3 (4), WS5 (5)                                      
+                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),1)   .OR.               &
+                         ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
+                           .AND. j == nys   )    .OR.                          &
+                         ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
+                           .AND. j == nyn   ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )       
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),1)  .AND.         &
+                                 BTEST(wall_flags_0(k,j+1,i),1)  .OR.          &
+                           .NOT. BTEST(wall_flags_0(k,j-1,i),1) )              &
+                                                     .OR.                      &
+                         ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
+                           .AND. j == nysv  )    .OR.                          &
+                         ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
+                           .AND. j == nyn-1 ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 4 )       
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
+                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),1)  .AND.                 &
+                         BTEST(wall_flags_0(k,j+2,i),1)  .AND.                 &
+                         BTEST(wall_flags_0(k,j-1,i),1) )                      &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 5 )       
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
+                ENDIF                                                          
+!                                                                              
+!--             u component - z-direction                                      
+!--             WS1 (6), WS3 (7), WS5 (8)                                      
+                IF ( k == nzb+1 )  THEN                                        
+                   k_mm = nzb                                                  
+                ELSE                                                           
+                   k_mm = k - 2                                                
+                ENDIF                                                          
+                IF ( k > nzt-1 )  THEN                                         
+                   k_pp = nzt+1                                                
+                ELSE                                                           
+                   k_pp = k + 2                                                
+                ENDIF                                                          
+                IF ( k > nzt-2 )  THEN                                         
+                   k_ppp = nzt+1                                               
+                ELSE                                                           
+                   k_ppp = k + 3                                               
+                ENDIF                                                          
+                                                                               
+                flag_set = .FALSE.                                             
+                IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),1)  .AND.               &
+                           BTEST(wall_flags_0(k,j,i),1)    .OR.                &
+                     .NOT. BTEST(wall_flags_0(k_pp,j,i),1) .AND.               &                              
+                           BTEST(wall_flags_0(k,j,i),1)    .OR.                &
+                     k == nzt )                                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 6 )       
+                   flag_set = .TRUE.                                           
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),1)    .OR.       &
+                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),1) ) .AND.      & 
+                               BTEST(wall_flags_0(k-1,j,i),1)  .AND.           &
+                               BTEST(wall_flags_0(k,j,i),1)    .AND.           &
+                               BTEST(wall_flags_0(k+1,j,i),1)  .AND.           &
+                               BTEST(wall_flags_0(k_pp,j,i),1) .OR.            &
+                               k == nzt - 1 )                                  &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 7 )       
+                   flag_set = .TRUE.                                           
+                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),1)  .AND.                &
+                         BTEST(wall_flags_0(k-1,j,i),1)   .AND.                &
+                         BTEST(wall_flags_0(k,j,i),1)     .AND.                &
+                         BTEST(wall_flags_0(k+1,j,i),1)   .AND.                &
+                         BTEST(wall_flags_0(k_pp,j,i),1)  .AND.                &
+                         BTEST(wall_flags_0(k_ppp,j,i),1) .AND.                &
+                         .NOT. flag_set )                                      &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 8 )
+                ENDIF
+
              ENDDO
           ENDDO
-       ENDIF
-
-       IF ( momentum_advec == 'ws-scheme' )  THEN
-!
-!--       Set advc_flags_1 to steer the degradation of the advection scheme in advec_ws
-!--       near topography, inflow- and outflow boundaries as well as bottom and
-!--       top of model domain. advc_flags_1 remains zero for all non-prognostic
-!--       grid points.
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-!  
-!--                At first, set flags to WS1. 
-!--                Since fluxes are swapped in advec_ws.f90, this is necessary to 
-!--                in order to handle the left/south flux.
-!--                near vertical walls. 
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 9 )
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 12 )
-!
-!--                u component - x-direction
-!--                WS1 (9), WS3 (10), WS5 (11)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),1)  .OR.             &
-                            ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                              .AND. i <= nxlu  )    .OR.                       &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr   ) )                             &
-                   THEN
-                       advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 9 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),1)  .AND.      &
-                                    BTEST(wall_flags_0(k,j,i+1),1)  .OR.       &
-                              .NOT. BTEST(wall_flags_0(k,j,i-1),1) )           &
-                                                        .OR.                   &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr-1 )    .OR.                       &
-                            ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                              .AND. i == nxlu+1) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 10 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 9 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),1)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i+2),1)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i-1),1) )                   &
-                   THEN    
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 11 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 9 )
-                   ENDIF
-!
-!--                u component - y-direction
-!--                WS1 (12), WS3 (13), WS5 (14)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),1)   .OR.            &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j == nys   )    .OR.                       &
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn   ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 12 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),1)  .AND.      &
-                                    BTEST(wall_flags_0(k,j+1,i),1)  .OR.       &
-                              .NOT. BTEST(wall_flags_0(k,j-1,i),1) )           &
-                                                        .OR.                   &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j == nysv  )    .OR.                       &
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn-1 ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 13 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 12 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),1)  .AND.              &
-                            BTEST(wall_flags_0(k,j+2,i),1)  .AND.              &
-                            BTEST(wall_flags_0(k,j-1,i),1) )                   &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 14 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 12 )
-                   ENDIF
-!
-!--                u component - z-direction
-!--                WS1 (15), WS3 (16), WS5 (17)
-                   IF ( k == nzb+1 )  THEN
-                      k_mm = nzb
-                   ELSE 
-                      k_mm = k - 2
-                   ENDIF
-                   IF ( k > nzt-1 )  THEN
-                      k_pp = nzt+1
-                   ELSE 
-                      k_pp = k + 2
-                   ENDIF
-                   IF ( k > nzt-2 )  THEN
-                      k_ppp = nzt+1
-                   ELSE 
-                      k_ppp = k + 3
-                   ENDIF                   
-
-                   flag_set = .FALSE.
-                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),1)  .AND.            &
-                              BTEST(wall_flags_0(k,j,i),1)    .OR.             &
-                        .NOT. BTEST(wall_flags_0(k_pp,j,i),1) .AND.            &                              
-                              BTEST(wall_flags_0(k,j,i),1)    .OR.             &
-                        k == nzt )                                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 15 )
-                      flag_set = .TRUE.                      
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),1)    .OR.    &
-                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),1) ) .AND.   & 
-                                  BTEST(wall_flags_0(k-1,j,i),1)  .AND.        &
-                                  BTEST(wall_flags_0(k,j,i),1)    .AND.        &
-                                  BTEST(wall_flags_0(k+1,j,i),1)  .AND.        &
-                                  BTEST(wall_flags_0(k_pp,j,i),1) .OR.         &
-                                  k == nzt - 1 )                               &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 16 )
-                      flag_set = .TRUE.
-                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),1)  .AND.             &
-                            BTEST(wall_flags_0(k-1,j,i),1)   .AND.             &
-                            BTEST(wall_flags_0(k,j,i),1)     .AND.             &
-                            BTEST(wall_flags_0(k+1,j,i),1)   .AND.             &
-                            BTEST(wall_flags_0(k_pp,j,i),1)  .AND.             &
-                            BTEST(wall_flags_0(k_ppp,j,i),1) .AND.             &
-                            .NOT. flag_set )                                   &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 17 )
-                   ENDIF
-
-                ENDDO
+       ENDDO
+!
+!--    v-component
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+!
+!--             At first, set flags to WS1. 
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!--             in order to handle the left/south flux.
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 9  )
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )
+!
+!--             v component - x-direction
+!--             WS1 (9), WS3 (10), WS5 (11)
+                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),2)  .OR.                &
+                         ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
+                           .AND. i == nxl   )    .OR.                          &
+                         ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
+                           .AND. i == nxr   ) )                                &
+               THEN                                                            
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 9 )       
+!                                                                              
+!--             WS3                                                            
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),2)   .AND.        &
+                                 BTEST(wall_flags_0(k,j,i+1),2) ) .OR.         &
+                           .NOT. BTEST(wall_flags_0(k,j,i-1),2)                &
+                                                 .OR.                          &
+                         ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
+                           .AND. i == nxlu  ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 10 )      
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )       
+                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),2)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i+2),2)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i-1),2) )                      &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 11 )      
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )       
+                ENDIF                                                          
+!                                                                              
+!--             v component - y-direction                                      
+!--             WS1 (12), WS3 (13), WS5 (14)                                   
+                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),2) .OR.                 &
+                         ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
+                           .AND. j <= nysv  )    .OR.                          &
+                         ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
+                           .AND. j == nyn   ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )      
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),2)  .AND.         &
+                                 BTEST(wall_flags_0(k,j+1,i),2)  .OR.          &
+                           .NOT. BTEST(wall_flags_0(k,j-1,i),2) )              &
+                                                     .OR.                      &
+                         ( (  bc_dirichlet_s .OR. bc_radiation_s )             &
+                           .AND. j == nysv+1)    .OR.                          &
+                         ( (  bc_dirichlet_n .OR. bc_radiation_n )             &
+                           .AND. j == nyn-1 ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 13 )      
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )      
+                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),2)  .AND.                 &
+                         BTEST(wall_flags_0(k,j+2,i),2)  .AND.                 &
+                         BTEST(wall_flags_0(k,j-1,i),2) )                      & 
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 14 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )
+                ENDIF
+!
+!--             v component - z-direction
+!--             WS1 (15), WS3 (16), WS5 (17)
+                IF ( k == nzb+1 )  THEN
+                   k_mm = nzb
+                ELSE 
+                   k_mm = k - 2
+                ENDIF
+                IF ( k > nzt-1 )  THEN
+                   k_pp = nzt+1
+                ELSE 
+                   k_pp = k + 2
+                ENDIF
+                IF ( k > nzt-2 )  THEN
+                   k_ppp = nzt+1
+                ELSE 
+                   k_ppp = k + 3
+                ENDIF  
+                
+                flag_set = .FALSE.
+                IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),2)  .AND.               &
+                           BTEST(wall_flags_0(k,j,i),2)    .OR.                &
+                     .NOT. BTEST(wall_flags_0(k_pp,j,i),2) .AND.               &                              
+                           BTEST(wall_flags_0(k,j,i),2)    .OR.                &
+                     k == nzt )                                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 15 )      
+                   flag_set = .TRUE.                                           
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),2)    .OR.       &
+                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),2) ) .AND.      & 
+                               BTEST(wall_flags_0(k-1,j,i),2)  .AND.           &
+                               BTEST(wall_flags_0(k,j,i),2)    .AND.           &
+                               BTEST(wall_flags_0(k+1,j,i),2)  .AND.           &
+                               BTEST(wall_flags_0(k_pp,j,i),2)  .OR.           &
+                               k == nzt - 1 )                                  &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 16 )      
+                   flag_set = .TRUE.                                           
+                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),2)  .AND.                &
+                         BTEST(wall_flags_0(k-1,j,i),2)   .AND.                &
+                         BTEST(wall_flags_0(k,j,i),2)     .AND.                &
+                         BTEST(wall_flags_0(k+1,j,i),2)   .AND.                &
+                         BTEST(wall_flags_0(k_pp,j,i),2)  .AND.                &
+                         BTEST(wall_flags_0(k_ppp,j,i),2) .AND.                &
+                         .NOT. flag_set )                                      &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 17 )
+                ENDIF
+
              ENDDO
           ENDDO
-
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-!
-!--                At first, set flags to WS1. 
-!--                Since fluxes are swapped in advec_ws.f90, this is necessary to 
-!--                in order to handle the left/south flux.
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 18 )
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 21 )
-!
-!--                v component - x-direction
-!--                WS1 (18), WS3 (19), WS5 (20)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),2)  .OR.             &
-                            ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                              .AND. i == nxl   )    .OR.                       &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr   ) )                             &
-                  THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 18 )
-!
-!--                WS3
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),2)   .AND.     &
-                                    BTEST(wall_flags_0(k,j,i+1),2) ) .OR.      &
-                              .NOT. BTEST(wall_flags_0(k,j,i-1),2)             &
-                                                    .OR.                       &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr-1 )    .OR.                       &
-                            ( ( bc_dirichlet_l .OR. bc_radiation_l )           &
-                              .AND. i == nxlu  ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 19 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 18 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),2)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i+2),2)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i-1),2) )                   &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 20 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 18 )
-                   ENDIF
-!
-!--                v component - y-direction
-!--                WS1 (21), WS3 (22), WS5 (23)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),2) .OR.              &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j <= nysv  )    .OR.                       &
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn   ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 21 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),2)  .AND.      &
-                                    BTEST(wall_flags_0(k,j+1,i),2)  .OR.       &
-                              .NOT. BTEST(wall_flags_0(k,j-1,i),2) )           &
-                                                        .OR.                   &
-                            ( (  bc_dirichlet_s .OR. bc_radiation_s )          &
-                              .AND. j == nysv+1)    .OR.                       &
-                            ( (  bc_dirichlet_n .OR. bc_radiation_n )          &
-                              .AND. j == nyn-1 ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 22 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 21 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),2)  .AND.              &
-                            BTEST(wall_flags_0(k,j+2,i),2)  .AND.              &
-                            BTEST(wall_flags_0(k,j-1,i),2) )                   & 
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 23 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 21 )
-                   ENDIF
-!
-!--                v component - z-direction
-!--                WS1 (24), WS3 (25), WS5 (26)
-                   IF ( k == nzb+1 )  THEN
-                      k_mm = nzb
-                   ELSE 
-                      k_mm = k - 2
-                   ENDIF
-                   IF ( k > nzt-1 )  THEN
-                      k_pp = nzt+1
-                   ELSE 
-                      k_pp = k + 2
-                   ENDIF
-                   IF ( k > nzt-2 )  THEN
-                      k_ppp = nzt+1
-                   ELSE 
-                      k_ppp = k + 3
-                   ENDIF  
-                   
-                   flag_set = .FALSE.
-                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),2)  .AND.            &
-                              BTEST(wall_flags_0(k,j,i),2)    .OR.             &
-                        .NOT. BTEST(wall_flags_0(k_pp,j,i),2) .AND.            &                              
-                              BTEST(wall_flags_0(k,j,i),2)    .OR.             &
-                        k == nzt )                                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 24 )
-                      flag_set = .TRUE.
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),2)    .OR.    &
-                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),2) ) .AND.   & 
-                                  BTEST(wall_flags_0(k-1,j,i),2)  .AND.        &
-                                  BTEST(wall_flags_0(k,j,i),2)    .AND.        &
-                                  BTEST(wall_flags_0(k+1,j,i),2)  .AND.        &
-                                  BTEST(wall_flags_0(k_pp,j,i),2)  .OR.        &
-                                  k == nzt - 1 )                               &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 25 )
-                      flag_set = .TRUE.
-                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),2)  .AND.             &
-                            BTEST(wall_flags_0(k-1,j,i),2)   .AND.             &
-                            BTEST(wall_flags_0(k,j,i),2)     .AND.             &
-                            BTEST(wall_flags_0(k+1,j,i),2)   .AND.             &
-                            BTEST(wall_flags_0(k_pp,j,i),2)  .AND.             &
-                            BTEST(wall_flags_0(k_ppp,j,i),2) .AND.             &
-                            .NOT. flag_set )                                   &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 26 )
-                   ENDIF
-
-                ENDDO
+       ENDDO
+!
+!--    w - component
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+!
+!--             At first, set flags to WS1. 
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!--             in order to handle the left/south flux.
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )
+                advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )
+!
+!--             w component - x-direction
+!--             WS1 (18), WS3 (19), WS5 (20)
+                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),3) .OR.                 &
+                         ( (  bc_dirichlet_l .OR. bc_radiation_l )             &
+                           .AND. i == nxl   )    .OR.                          &
+                         ( (  bc_dirichlet_r .OR. bc_radiation_r )             &
+                           .AND. i == nxr   ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )      
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),3)  .AND.         &
+                                 BTEST(wall_flags_0(k,j,i+1),3)  .OR.          &
+                           .NOT. BTEST(wall_flags_0(k,j,i-1),3) )              &
+                                                     .OR.                      &
+                         ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( bc_dirichlet_l .OR.  bc_radiation_l )             &
+                           .AND. i == nxlu  ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 19 )      
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
+                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),3)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i+2),3)  .AND.                 &
+                         BTEST(wall_flags_0(k,j,i-1),3) )                      &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i),20 )       
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
+                ENDIF                                                          
+!                                                                              
+!--             w component - y-direction                                      
+!--             WS1 (21), WS3 (22), WS5 (23)                                   
+                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),3) .OR.                 &
+                         ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
+                           .AND. j == nys   )    .OR.                          &
+                         ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
+                           .AND. j == nyn   ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )      
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),3)  .AND.         &
+                                 BTEST(wall_flags_0(k,j+1,i),3)  .OR.          &
+                           .NOT. BTEST(wall_flags_0(k,j-1,i),3) )              &
+                                                     .OR.                      &
+                         ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
+                           .AND. j == nysv  )    .OR.                          &
+                         ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
+                           .AND. j == nyn-1 ) )                                &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 22 )      
+!                                                                              
+!--                Clear flag for WS1                                          
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )      
+                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),3)  .AND.                 &
+                         BTEST(wall_flags_0(k,j+2,i),3)  .AND.                 &
+                         BTEST(wall_flags_0(k,j-1,i),3) )                      &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 23 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )
+                ENDIF
+!
+!--             w component - z-direction
+!--             WS1 (24), WS3 (25), WS5 (26)
+                flag_set = .FALSE.
+                IF ( k == nzb+1 )  THEN
+                   k_mm = nzb
+                ELSE
+                   k_mm = k - 2
+                ENDIF
+                IF ( k > nzt-1 )  THEN
+                   k_pp = nzt+1
+                ELSE 
+                   k_pp = k + 2
+                ENDIF
+                IF ( k > nzt-2 )  THEN
+                   k_ppp = nzt+1
+                ELSE 
+                   k_ppp = k + 3
+                ENDIF  
+                
+                IF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.             &
+                       .NOT. BTEST(wall_flags_0(k,j,i),3)    .AND.             &
+                             BTEST(wall_flags_0(k+1,j,i),3) )  .OR.            &
+                     ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.             &
+                             BTEST(wall_flags_0(k,j,i),3) )  .OR.              &
+                     ( .NOT. BTEST(wall_flags_0(k+1,j,i),3)  .AND.             &
+                             BTEST(wall_flags_0(k,j,i),3) )  .OR.              &        
+                     k == nzt )                                                &
+                THEN
+!
+!--                Please note, at k == nzb_w_inner(j,i) a flag is explictely
+!--                set, although this is not a prognostic level. However, 
+!--                contrary to the advection of u,v and s this is necessary
+!--                because flux_t(nzb_w_inner(j,i)) is used for the tendency
+!--                at k == nzb_w_inner(j,i)+1.
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 24 )
+                   flag_set = .TRUE.
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),3)     .OR.      &
+                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),3) ) .AND.      &
+                                 BTEST(wall_flags_0(k-1,j,i),3)  .AND.         &
+                                 BTEST(wall_flags_0(k,j,i),3)    .AND.         &
+                                 BTEST(wall_flags_0(k+1,j,i),3)  .OR.          &
+                         k == nzt - 1 )                                        &
+                THEN                                                           
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 25 )      
+                   flag_set = .TRUE.                                           
+                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),3)  .AND.                &
+                         BTEST(wall_flags_0(k-1,j,i),3)   .AND.                &
+                         BTEST(wall_flags_0(k,j,i),3)     .AND.                &
+                         BTEST(wall_flags_0(k+1,j,i),3)   .AND.                &
+                         BTEST(wall_flags_0(k_pp,j,i),3)  .AND.                &
+                         BTEST(wall_flags_0(k_ppp,j,i),3) .AND.                &
+                         .NOT. flag_set )                                      &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 26 )
+                ENDIF
+
              ENDDO
           ENDDO
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-!
-!--                At first, set flags to WS1. 
-!--                Since fluxes are swapped in advec_ws.f90, this is necessary to 
-!--                in order to handle the left/south flux.
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 27 )
-                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 30 )
-!
-!--                w component - x-direction
-!--                WS1 (27), WS3 (28), WS5 (29)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),3) .OR.              &
-                            ( (  bc_dirichlet_l .OR. bc_radiation_l )          &
-                              .AND. i == nxl   )    .OR.                       &
-                            ( (  bc_dirichlet_r .OR. bc_radiation_r )          &
-                              .AND. i == nxr   ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 27 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),3)  .AND.      &
-                                    BTEST(wall_flags_0(k,j,i+1),3)  .OR.       &
-                              .NOT. BTEST(wall_flags_0(k,j,i-1),3) )           &
-                                                        .OR.                   &
-                            ( ( bc_dirichlet_r .OR. bc_radiation_r )           &
-                              .AND. i == nxr-1 )    .OR.                       &
-                            ( ( bc_dirichlet_l .OR.  bc_radiation_l )          &
-                              .AND. i == nxlu  ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 28 )
-!   
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 27 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),3)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i+2),3)  .AND.              &
-                            BTEST(wall_flags_0(k,j,i-1),3) )                   &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i),29 )
-!   
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 27 )
+       ENDDO
+!
+!--    Exchange ghost points for advection flags
+       CALL exchange_horiz_int( advc_flags_m, nys, nyn, nxl, nxr, nzt, nbgp )
+!
+!--    Set boundary flags at inflow and outflow boundary in case of 
+!--    non-cyclic boundary conditions.
+       IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
+          advc_flags_m(:,:,nxl-1) = advc_flags_m(:,:,nxl)
+       ENDIF
+
+       IF ( bc_dirichlet_r  .OR.  bc_radiation_r )  THEN
+         advc_flags_m(:,:,nxr+1) = advc_flags_m(:,:,nxr)
+       ENDIF
+
+       IF ( bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
+          advc_flags_m(:,nyn+1,:) = advc_flags_m(:,nyn,:)
+       ENDIF
+
+       IF ( bc_dirichlet_s  .OR.  bc_radiation_s )  THEN
+          advc_flags_m(:,nys-1,:) = advc_flags_m(:,nys,:)
+       ENDIF
+
+    END SUBROUTINE ws_init_flags_momentum
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialization of flags to control the order of the advection scheme near
+!> solid walls and non-cyclic inflow boundaries, where the order is sucessively
+!> degraded. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE ws_init_flags_scalar( non_cyclic_l, non_cyclic_n, non_cyclic_r, &
+                                     non_cyclic_s, advc_flag, extensive_degrad )
+
+
+       INTEGER(iwp) ::  i     !< index variable along x
+       INTEGER(iwp) ::  j     !< index variable along y
+       INTEGER(iwp) ::  k     !< index variable along z
+       INTEGER(iwp) ::  k_mm  !< dummy index along z
+       INTEGER(iwp) ::  k_pp  !< dummy index along z
+       INTEGER(iwp) ::  k_ppp !< dummy index along z
+       
+       INTEGER(iwp), INTENT(INOUT), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::&
+                                                  advc_flag !< flag array to control order of scalar advection
+       
+       LOGICAL ::  flag_set     !< steering variable for advection flags
+       LOGICAL ::  non_cyclic_l !< flag that indicates non-cyclic boundary on the left
+       LOGICAL ::  non_cyclic_n !< flag that indicates non-cyclic boundary on the north
+       LOGICAL ::  non_cyclic_r !< flag that indicates non-cyclic boundary on the right
+       LOGICAL ::  non_cyclic_s !< flag that indicates non-cyclic boundary on the south
+       
+       LOGICAL, OPTIONAL ::  extensive_degrad !< flag indicating that extensive degradation is required, e.g. for 
+                                              !< passive scalars nearby topography along the horizontal directions,
+                                              !< as no monotonic limiter can be applied there 
+!
+!--    Set flags to steer the degradation of the advection scheme in advec_ws
+!--    near topography, inflow- and outflow boundaries as well as bottom and
+!--    top of model domain. advc_flags_m remains zero for all non-prognostic
+!--    grid points.
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                IF ( .NOT.  BTEST(wall_flags_0(k,j,i),0) )  CYCLE
+!
+!--             scalar - x-direction
+!--             WS1 (0), WS3 (1), WS5 (2)
+                IF ( ( .NOT. BTEST(wall_flags_0(k,j,i+1),0)                    &
+                 .OR.  .NOT. BTEST(wall_flags_0(k,j,i+2),0)                    &   
+                 .OR.  .NOT. BTEST(wall_flags_0(k,j,i-1),0) )                  &
+                   .OR.  ( non_cyclic_l  .AND.  i == 0  )                      &
+                   .OR.  ( non_cyclic_r  .AND.  i == nx ) )  THEN           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )             
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+3),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i+1),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i+2),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i-1),0)                &
+                         )                       .OR.                          &
+                         ( .NOT. BTEST(wall_flags_0(k,j,i-2),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i+1),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i+2),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j,i-1),0)                &
+                         )                                                     &
+                                                 .OR.                          &
+                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.              &
+                         ( non_cyclic_l  .AND.  i == 1    ) )  THEN           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )             
+                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j,i+2),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j,i+3),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j,i-1),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j,i-2),0) )                      &
+                THEN                                                           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )             
+                ENDIF                                                          
+!                                                                              
+!--             scalar - y-direction                                           
+!--             WS1 (3), WS3 (4), WS5 (5)                                      
+                IF ( ( .NOT. BTEST(wall_flags_0(k,j+1,i),0)                    &
+                 .OR.  .NOT. BTEST(wall_flags_0(k,j+2,i),0)                    &   
+                 .OR.  .NOT. BTEST(wall_flags_0(k,j-1,i),0))                   &
+                   .OR.  ( non_cyclic_s  .AND.  j == 0  )                      &
+                   .OR.  ( non_cyclic_n  .AND.  j == ny ) )  THEN                                                           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 3 )             
+!                                                                              
+!--             WS3                                                            
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+3,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j+1,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j+2,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j-1,i),0)                &
+                         )                       .OR.                          &
+                         ( .NOT. BTEST(wall_flags_0(k,j-2,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j+1,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j+2,i),0)                &
+                    .AND.        BTEST(wall_flags_0(k,j-1,i),0)                &
+                         )                                                     &
+                                                 .OR.                          &
+                         ( non_cyclic_s  .AND.  j == 1    )  .OR.              &
+                         ( non_cyclic_n  .AND.  j == ny-1 ) )  THEN           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 4 )             
+!                                                                              
+!--             WS5                                                            
+                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j+2,i),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j+3,i),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j-1,i),0)                        &
+                   .AND. BTEST(wall_flags_0(k,j-2,i),0) )                      &
+                THEN                                                           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 5 )             
+                ENDIF
+!
+!--             Near topography, set horizontal advection scheme to 1st order 
+!--             for passive scalars, even if only one direction may be 
+!--             blocked by topography. These locations will be identified
+!--             by wall_flags_0 bit 31. Note, since several modules define 
+!--             advection flags but may apply different scalar boundary 
+!--             conditions, bit 31 is temporarily stored on advc_flags. 
+!--             Moreover, note that this extended degradtion for passive 
+!--             scalars is not required for the vertical direction as there 
+!--             the monotonic limiter can be applied. 
+                IF ( PRESENT( extensive_degrad ) )  THEN
+                   IF ( extensive_degrad )  THEN
+!
+!--                   At all grid points that are within a three-grid point
+!--                   range to topography, set 1st-order scheme.
+                      IF( BTEST( advc_flag(k,j,i), 31 ) )  THEN
+!
+!--                      Clear flags that might indicate higher-order 
+!--                      advection along x- and y-direction.
+                         advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
+                         advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 2 )
+                         advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 4 )
+                         advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 5 )
+!
+!--                      Set flags that indicate 1st-order advection along
+!--                      x- and y-direction.
+                         advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )
+                         advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 3 )  
+                      ENDIF
+!
+!--                   Adjacent to this extended degradation zone, successively
+!--                   upgrade the order of the scheme if this grid point isn't 
+!--                   flagged with bit 31 (indicating extended degradation 
+!--                   zone). 
+                      IF ( .NOT. BTEST( advc_flag(k,j,i), 31 ) )  THEN
+!
+!--                      x-direction. First, clear all previous settings, than
+!--                      set flag for 3rd-order scheme.
+                         IF ( BTEST( advc_flag(k,j,i-1), 31 )  .AND.        &
+                              BTEST( advc_flag(k,j,i+1), 31 ) )  THEN
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 0 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 2 )
+                            
+                            advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )
+                         ENDIF
+!
+!--                      x-direction. First, clear all previous settings, than
+!--                      set flag for 5rd-order scheme.
+                         IF ( .NOT. BTEST( advc_flag(k,j,i-1), 31 )  .AND.  &
+                                    BTEST( advc_flag(k,j,i-2), 31 )  .AND.  &
+                              .NOT. BTEST( advc_flag(k,j,i+1), 31 )  .AND.  &
+                                    BTEST( advc_flag(k,j,i+2), 31 ) )  THEN
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 0 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 2 )
+                            
+                            advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )
+                         ENDIF
+!
+!--                      y-direction. First, clear all previous settings, than
+!--                      set flag for 3rd-order scheme.
+                         IF ( BTEST( advc_flag(k,j-1,i), 31 )  .AND.        &
+                              BTEST( advc_flag(k,j+1,i), 31 ) )  THEN
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 3 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 4 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 5 )
+                            
+                            advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 4 )
+                         ENDIF
+!
+!--                      y-direction. First, clear all previous settings, than
+!--                      set flag for 5rd-order scheme.
+                         IF ( .NOT. BTEST( advc_flag(k,j-1,i), 31 )  .AND.  &
+                                    BTEST( advc_flag(k,j-2,i), 31 )  .AND.  &
+                              .NOT. BTEST( advc_flag(k,j+1,i), 31 )  .AND.  &
+                                    BTEST( advc_flag(k,j+2,i), 31 ) )  THEN
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 3 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 4 )
+                            advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 5 )
+                            
+                            advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 5 )
+                         ENDIF
+                      ENDIF
+                   
                    ENDIF
-!
-!--                w component - y-direction
-!--                WS1 (30), WS3 (31), WS5 (32)
-                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),3) .OR.              &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j == nys   )    .OR.                       &
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn   ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 30 )
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),3)  .AND.      &
-                                    BTEST(wall_flags_0(k,j+1,i),3)  .OR.       &
-                              .NOT. BTEST(wall_flags_0(k,j-1,i),3) )           &
-                                                        .OR.                   &
-                            ( ( bc_dirichlet_s .OR. bc_radiation_s )           &
-                              .AND. j == nysv  )    .OR.                       &
-                            ( ( bc_dirichlet_n .OR. bc_radiation_n )           &
-                              .AND. j == nyn-1 ) )                             &
-                   THEN
-                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 31 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 30 )
-                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),3)  .AND.              &
-                            BTEST(wall_flags_0(k,j+2,i),3)  .AND.              &
-                            BTEST(wall_flags_0(k,j-1,i),3) )                   &
-                   THEN
-                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 0 )
-!
-!--                   Clear flag for WS1
-                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 30 )
+                   
+!
+!--                Near lateral boundary flags might be overwritten. Set
+!--                them again. 
+!--                x-direction
+                   IF ( ( non_cyclic_l  .AND.  i == 0  )  .OR.                 &
+                        ( non_cyclic_r  .AND.  i == nx ) )  THEN
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 0 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 2 )
+                         
+                      advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )
                    ENDIF
-!
-!--                w component - z-direction
-!--                WS1 (33), WS3 (34), WS5 (35)
-                   flag_set = .FALSE.
-                   IF ( k == nzb+1 )  THEN
-                      k_mm = nzb
-                   ELSE
-                      k_mm = k - 2
+                   
+                   IF ( ( non_cyclic_l  .AND.  i == 1    )  .OR.               &
+                        ( non_cyclic_r  .AND.  i == nx-1 ) )  THEN
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 0 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 2 )
+                         
+                      advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )
                    ENDIF
-                   IF ( k > nzt-1 )  THEN
-                      k_pp = nzt+1
-                   ELSE 
-                      k_pp = k + 2
+!
+!--                y-direction
+                   IF ( ( non_cyclic_n  .AND.  j == 0  )  .OR.                 &
+                        ( non_cyclic_s  .AND.  j == ny ) )  THEN
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 3 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 4 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 5 )
+                         
+                      advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 3 )
                    ENDIF
-                   IF ( k > nzt-2 )  THEN
-                      k_ppp = nzt+1
-                   ELSE 
-                      k_ppp = k + 3
-                   ENDIF  
                    
-                   IF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.          &
-                          .NOT. BTEST(wall_flags_0(k,j,i),3)    .AND.          &
-                                BTEST(wall_flags_0(k+1,j,i),3) )  .OR.         &
-                        ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.          &
-                                BTEST(wall_flags_0(k,j,i),3) )  .OR.           &
-                        ( .NOT. BTEST(wall_flags_0(k+1,j,i),3)  .AND.          &
-                                BTEST(wall_flags_0(k,j,i),3) )  .OR.           &        
-                        k == nzt )                                             &
-                   THEN
-!
-!--                   Please note, at k == nzb_w_inner(j,i) a flag is explictely
-!--                   set, although this is not a prognostic level. However, 
-!--                   contrary to the advection of u,v and s this is necessary
-!--                   because flux_t(nzb_w_inner(j,i)) is used for the tendency
-!--                   at k == nzb_w_inner(j,i)+1.
-                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 1 )
-                      flag_set = .TRUE.
-                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),3)     .OR.   &
-                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),3) ) .AND.   &
-                                    BTEST(wall_flags_0(k-1,j,i),3)  .AND.      &
-                                    BTEST(wall_flags_0(k,j,i),3)    .AND.      &
-                                    BTEST(wall_flags_0(k+1,j,i),3)  .OR.       &
-                            k == nzt - 1 )                                     &
-                   THEN
-                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 2 )
-                      flag_set = .TRUE.
-                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),3)  .AND.             &
-                            BTEST(wall_flags_0(k-1,j,i),3)   .AND.             &
-                            BTEST(wall_flags_0(k,j,i),3)     .AND.             &
-                            BTEST(wall_flags_0(k+1,j,i),3)   .AND.             &
-                            BTEST(wall_flags_0(k_pp,j,i),3)  .AND.             &
-                            BTEST(wall_flags_0(k_ppp,j,i),3) .AND.             &
-                            .NOT. flag_set )                                   &
-                   THEN
-                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 3 )
+                   IF ( ( non_cyclic_n  .AND.  j == 1    )  .OR.               &
+                        ( non_cyclic_s  .AND.  j == ny-1 ) )  THEN
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 3 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 4 )
+                      advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 5 )
+                         
+                      advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 4 )
                    ENDIF
-
-                ENDDO
+                   
+                ENDIF
+                
+                
+!                                                                              
+!--             scalar - z-direction                                           
+!--             WS1 (6), WS3 (7), WS5 (8)                                      
+                IF ( k == nzb+1 )  THEN                                        
+                   k_mm = nzb                                                  
+                ELSE                                                           
+                   k_mm = k - 2                                                
+                ENDIF                                                          
+                IF ( k > nzt-1 )  THEN                                         
+                   k_pp = nzt+1                                                
+                ELSE                                                           
+                   k_pp = k + 2                                                
+                ENDIF                                                          
+                IF ( k > nzt-2 )  THEN                                         
+                   k_ppp = nzt+1                                               
+                ELSE                                                           
+                   k_ppp = k + 3                                               
+                ENDIF                                                          
+                                                                               
+                flag_set = .FALSE.                                             
+                IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),0)  .AND.               &
+                           BTEST(wall_flags_0(k,j,i),0)    .OR.                &
+                     .NOT. BTEST(wall_flags_0(k_pp,j,i),0) .AND.               &                              
+                           BTEST(wall_flags_0(k,j,i),0)    .OR.                &
+                     k == nzt )                                                &
+                THEN                                                           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 6 )             
+                   flag_set = .TRUE.                                           
+                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),0)    .OR.       &
+                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),0) ) .AND.      & 
+                               BTEST(wall_flags_0(k-1,j,i),0)  .AND.           &
+                               BTEST(wall_flags_0(k,j,i),0)    .AND.           &
+                               BTEST(wall_flags_0(k+1,j,i),0)  .AND.           &
+                               BTEST(wall_flags_0(k_pp,j,i),0) .OR.            &    
+                         k == nzt - 1 )                                        &
+                THEN                                                           
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 7 )             
+                   flag_set = .TRUE.                                           
+                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),0)                       &
+                  .AND.  BTEST(wall_flags_0(k-1,j,i),0)                        &
+                  .AND.  BTEST(wall_flags_0(k,j,i),0)                          &
+                  .AND.  BTEST(wall_flags_0(k+1,j,i),0)                        &
+                  .AND.  BTEST(wall_flags_0(k_pp,j,i),0)                       &
+                  .AND.  BTEST(wall_flags_0(k_ppp,j,i),0)                      &
+                  .AND. .NOT. flag_set )                                       &
+                THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 8 )
+                ENDIF
+
              ENDDO
           ENDDO
-
+       ENDDO
+!
+!--    Exchange 3D integer wall_flags.
+!
+!--    Exchange ghost points for advection flags
+       CALL exchange_horiz_int( advc_flag, nys, nyn, nxl, nxr, nzt, nbgp )
+!
+!--    Set boundary flags at inflow and outflow boundary in case of 
+!--    non-cyclic boundary conditions.
+       IF ( non_cyclic_l )  THEN
+          advc_flag(:,:,nxl-1) = advc_flag(:,:,nxl)
        ENDIF
 
-
-!
-!--    Exchange 3D integer wall_flags.
-       IF ( momentum_advec == 'ws-scheme' .OR. scalar_advec == 'ws-scheme'     &
-          )  THEN  
-!
-!--       Exchange ghost points for advection flags
-          CALL exchange_horiz_int( advc_flags_1, nys, nyn, nxl, nxr, nzt, nbgp )
-          CALL exchange_horiz_int( advc_flags_2, nys, nyn, nxl, nxr, nzt, nbgp )
-!
-!--       Set boundary flags at inflow and outflow boundary in case of 
-!--       non-cyclic boundary conditions.
-          IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
-             advc_flags_1(:,:,nxl-1) = advc_flags_1(:,:,nxl)
-             advc_flags_2(:,:,nxl-1) = advc_flags_2(:,:,nxl)
-          ENDIF
-
-          IF ( bc_dirichlet_r  .OR.  bc_radiation_r )  THEN
-            advc_flags_1(:,:,nxr+1) = advc_flags_1(:,:,nxr)
-            advc_flags_2(:,:,nxr+1) = advc_flags_2(:,:,nxr)
-          ENDIF
-
-          IF ( bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
-             advc_flags_1(:,nyn+1,:) = advc_flags_1(:,nyn,:)
-             advc_flags_2(:,nyn+1,:) = advc_flags_2(:,nyn,:)
-          ENDIF
-
-          IF ( bc_dirichlet_s  .OR.  bc_radiation_s )  THEN
-             advc_flags_1(:,nys-1,:) = advc_flags_1(:,nys,:)
-             advc_flags_2(:,nys-1,:) = advc_flags_2(:,nys,:)
-          ENDIF
+       IF ( non_cyclic_r )  THEN
+         advc_flag(:,:,nxr+1) = advc_flag(:,:,nxr)
+       ENDIF
+
+       IF ( non_cyclic_n )  THEN
+          advc_flag(:,nyn+1,:) = advc_flag(:,nyn,:)
+       ENDIF
+
+       IF ( non_cyclic_s )  THEN
+          advc_flag(:,nys-1,:) = advc_flag(:,nys,:)
+       ENDIF
   
-       ENDIF
-
-
-    END SUBROUTINE ws_init_flags
-
-
+
+
+    END SUBROUTINE ws_init_flags_scalar   
+    
 !------------------------------------------------------------------------------!
 ! Description:
